﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        [DllImport("user32", EntryPoint = "HideCaret")]
        private static extern bool HideCaret(IntPtr hWnd);
        static System.Timers.Timer timer;
      //  private int i = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }

        private void RMsg(string msg)
        {
            string r = msg.TrimStart(';').TrimEnd('?');
            dataGridView1.Rows.Add(r);
           // textBox1.Text = msg;
            textBox1.Text = "";
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)59)
            {
                    Form2 frm = new Form2(textBox1.Text);
                    frm.myDelMsg = new Form2.MyDelMsg(RMsg);
                    frm.ShowDialog();
                    textBox1.Text = ""; 
            }

        }

        private void dataGridView1_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Rectangle rectangle = new Rectangle(e.RowBounds.Location.X,
            e.RowBounds.Location.Y,
            dataGridView1.RowHeadersWidth - 4,
            e.RowBounds.Height);

            TextRenderer.DrawText(e.Graphics, (e.RowIndex + 1).ToString(),
            dataGridView1.RowHeadersDefaultCellStyle.Font,
            rectangle,
            dataGridView1.RowHeadersDefaultCellStyle.ForeColor,
            TextFormatFlags.VerticalCenter | TextFormatFlags.Right);  //以上全部为设置dgv编号
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Focus(); 

            dataGridView1.Dock = System.Windows.Forms.DockStyle.Fill;
            dataGridView1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;//设置datagridview跟随窗口大小
            dataGridView1.AllowUserToAddRows = false;//最后一行不显示
            textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            textBox1.GotFocus += textBox1_GotFocus;
            textBox1.MouseDown += textBox1_MouseDown;//隐藏textbox光标
        }

        private void textBox1_MouseDown(object sender, MouseEventArgs e)
        {
            HideCaret(((TextBox)sender).Handle);
        }
        void textBox1_GotFocus(object sender, EventArgs e)//textBox隐藏光标
        {
            HideCaret((sender as TextBox).Handle);
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            //this.i++;
            //if (this.i == 2)
            //{
            //    int rowIndex = dataGridView1.CurrentRow.Index;
            //    dataGridView1.Rows[rowIndex].ReadOnly = false;
            //    this.i = 0;
            //}
           
        }

        private void 导出为txt文本ToolStripMenuItem_Click(object sender, EventArgs e)
        {
           

            Stream myStream;
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            saveFileDialog1.Filter = "txt files   (*.txt)|*.txt";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                if ((myStream = saveFileDialog1.OpenFile()) != null)
                {
                    using (StreamWriter sw = new StreamWriter(myStream))
                    {
                        for (int i = 0; i < dataGridView1.Rows.Count; i++)
                        {
                            sw.WriteLine(dataGridView1.Rows[0].Cells["a"].Value.ToString());
                        }
                      //  sw.Write(dataGridView1.Rows[0].Cells["a"].Value.ToString());
                    }

                    myStream.Close();
                    MessageBox.Show("Saved Successfully!");
                }
            } 
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            timer = new System.Timers.Timer(1000);//实例化Timer类，设置间隔时间为1000毫秒 就是1秒；
            timer.Elapsed += new System.Timers.ElapsedEventHandler(theout);//到达时间的时候执行事件；
            timer.AutoReset = true;//设置是执行一次（false）还是一直执行(true)；
            timer.Enabled = true;//是否执行System.Timers.Timer.Elapsed事件；
        }

        public void theout(object source, System.Timers.ElapsedEventArgs e)
        {
            this.Invoke(new TextOption(f));//invok 委托实现跨线程的调用

        }
        delegate void TextOption();//定义一个委托

        void f()
        {
            textBox1.Text = "";
            timer.Stop();
            timer.Close();
            for (int r = 0; r < this.dataGridView1.Rows.Count; r++)
            {
                string value = this.dataGridView1.Rows[r].Cells[0].Value == null ? "" : this.dataGridView1.Rows[r].Cells[0].Value.ToString();
                if (value.Length < 9)
                {
                    this.dataGridView1.Rows.RemoveAt(r);
                    r--;
                }
            }
            
        }

        private void textBox1_Validated(object sender, EventArgs e)//textbox失去光标时重新获取
        {
            textBox1.Focus(); 
        }
    }
}
